<template>
    <nav id='bar' class='navbar is-fixed-top'>
        <div class='navbar-brand'>
            <div class='navbar-item'>
                Mapview
            </div>

            <a role='button' class='navbar-burger' data-target='navMenu' aria-label='menu' aria-expanded='false'>
                <span aria-hidden='true'></span>
                <span aria-hidden='true'></span>
                <span aria-hidden='true'></span>
            </a>
        </div>
        <div id='navMenu' class='navbar-menu'>
            <div class='navbar-start'>
                <div class='navbar-item'>|</div>

                <bar-tile-selector />

                <dropdown icon="SEARCH" centered=true>
                    <a v-on:click="map._mapboxMap.zoomIn()" class="navbar-item">
                        <icon-base name='ZOOM_IN' />
                    </a>
                    <a v-on:click="map._mapboxMap.zoomOut()" class="navbar-item">
                        <icon-base name='ZOOM_OUT' />
                    </a>
                    <a v-on:click="map.zoomReset()" class="navbar-item">
                        <icon-base name='GLOBE' />
                    </a>
                </dropdown>

                <a v-on:click='map.selectArea()' class='navbar-item'>
                    <icon-base name='CROP' />
                </a>

                <a v-on:click='map.clean()' class='navbar-item'>
                    <icon-base name='TRASH' />
                </a>

                <div class='navbar-item'>|</div>

                <bar-icon-selector />

                <dropdown icon="TOGGLE" centered=true>
                    <a v-on:click='map.paths.toggleMarkers()' class='navbar-item is-anchor-toggler'>
                        <icon-base name='CIRCLE_OFF' />
                    </a>

                    <a v-on:click='map.paths.toggleMarkersText()' class='navbar-item  is-anchor-toggler'>
                        <icon-base name='TEXT_OFF' />
                    </a>

                    <a v-on:click='map.paths.toggleLines(map._mapboxMap)' class='navbar-item is-anchor-toggler'>
                        <icon-base name='SHARE_OFF' />
                    </a>

                    <a v-on:click='map.images.toggle(map._mapboxMap)' class='navbar-item is-anchor-toggler'>
                        <icon-base name='IMAGE_OFF' />
                    </a>
                </dropdown>

                <dropdown icon="SLIDERS" centered=true>
                    <bar-limit-setter name='low' />
                    <hr class="navbar-divider has-small-top-margin">
                    <bar-limit-setter name='high' />
                </dropdown>
            </div>

            <div class='navbar-end'>
                <a v-on:click='test()' class='navbar-item'>
                    <icon-base name='PLAY_CIRCLE' />
                </a>

                <a class='navbar-item file'>
                    <label class='file-label'>
                        <input v-on:change='file($event.target)' class='file-input' type='file' accept='.f25,.json,.png,.jpg,.jpeg'>
                        <span class='file-cta'>
                            <icon-base name='FILE_PLUS' />
                        </span>
                    </label>
                </a>

                <a v-on:click='save()' class='navbar-item'>
                    <icon-base name='ARCHIVE' />
                </a>
            </div>
        </div>
    </nav>
</template>

<script lang='ts'>
    import { Component, Prop, Vue } from 'vue-property-decorator';
    import { State, Getter, Action, Mutation, namespace } from 'vuex-class';
    import BarIconSelector from './BarIconSelector.vue';
    import BarLimitSetter from './BarLimitSetter.vue';
    import BarTileSelector from './BarTileSelector.vue';
    import Dropdown from './Dropdown.vue';
    import IconBase from './IconBase.vue';

    import * as CircularJSON from 'circular-json';
    import { Importer } from '@/ts/importer';
    import { Mapview } from '@/ts/mapview';

    @Component({
        components: {
            BarIconSelector,
            BarLimitSetter,
            BarTileSelector,
            Dropdown,
            IconBase,
        },
    })
    export default class Bar extends Vue {
        @State('map') private map!: Mapview;

        private file(element: any): void {
            new Importer().readFile(this.map, element.files[0]);
        }

        private mounted(): void {
            const $navbarDropdownTogglers = Array.prototype.slice.call(document.querySelectorAll('.is-dropdown-toggler'), 0);
            if ($navbarDropdownTogglers.length > 0) {
                $navbarDropdownTogglers.forEach((element: any) => {
                    element.addEventListener('click', () => {
                        element.parentNode.classList.toggle('is-active');
                    });
                });
            }

            const $navbarAnchorTogglers = Array.prototype.slice.call(document.querySelectorAll('.is-anchor-toggler'), 0);
            if ($navbarAnchorTogglers.length > 0) {
                $navbarAnchorTogglers.forEach((element: any) => {
                    element.addEventListener('click', () => {
                        element.classList.toggle('is-active');
                    });
                });
            }

            const $navbarBurgers = Array.prototype.slice.call(document.querySelectorAll('.navbar-burger'), 0);
            if ($navbarBurgers.length > 0) {
                $navbarBurgers.forEach((element: any) => {
                    element.addEventListener('click', () => {
                        const target = element.dataset.target;
                        const $target = document.getElementById(target);
                        element.classList.toggle('is-active');
                        if ($target !== null) {
                            $target.classList.toggle('is-active');
                        }
                    });
                });
            }
        }

        private save(): void {
            if (this.map._mapboxMap) {
                this.map.mapCenter = this.map._mapboxMap.getCenter();
                this.map.mapZoom = this.map._mapboxMap.getZoom();
            }

            const DATA: string = CircularJSON.stringify(this.map, (key: any, value: any): any => {
                const REGEXP: RegExp = new RegExp('^_.*$');
                if (REGEXP.test(key)) {
                    return undefined;
                }
                return value;
            }, '    ');

            const BLOB: Blob = new Blob([DATA], {type: 'text/plain'});
            const EVENT: any = document.createEvent('MouseEvents');
            const ANCHOR: HTMLAnchorElement = document.createElement('a');
            ANCHOR.download = 'save.json';
            ANCHOR.href = window.URL.createObjectURL(BLOB);
            EVENT.initEvent('click');
            ANCHOR.dispatchEvent(EVENT);
        }

        private test(): void {
            new Importer().readTestFile(this.map);
        }
    }
</script>

<style>
    .has-small-top-margin {
        margin-top: 0.75rem;
    }
</style>

<style scoped>
    .navbar {
        height: 80px;
        margin: 5vh 10vw;
        padding: 15px 2vw;

        background-color: white !important;
        border-radius: 25px;
        
        -webkit-user-select: none;
    }

    .navbar-item .is-active {
        background-color: #f9f9f9;
        color: #4a4a4a;
    }

    .navbar-item:hover .is-active {
        color: #3273DC;
    }

    .navbar-item .file-cta {
        padding-left: 0;
        padding-right: 0;
        background-color: white;
        border-color: white;
    }

    .navbar-item:hover .file-cta {
        color: #3273DC;
        background-color: #f9f9f9;
        border-color: #f9f9f9;
    }

    .file-label:hover .file-cta {
        background-color: #f9f9f9;
        border-color: #f9f9f9;
    }

    .is-horizontal-center {
        justify-content: center;
    }

    @media screen and (min-width: 1088px) {
        a.navbar-item.is-active:not(:hover) {
            background-color: #f9f9f9;
            color: #4a4a4a;
        }

        a.navbar-item.is-active:hover {
            color: #3273DC;
        }
    }
</style>
